#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#include    "kroffrsv.h"
/*DEFINE*/
#define		NOSIGN		unsigned

#define		HIGHP		5
/*EXTERN*/
extern	char	*fgetl();
extern	char	*(*ismac());
extern	char	*filepush();
extern	char	*filepop();
extern	char	*zapcom();
extern	char	*fgetlk();
#ifdef      DIAG
#define     LOOP    64
#else
#define     LOOP    512
#endif
#define     NMAC    128
#define     KSTR    '$'
#define     KMAC    '.'
#define     KESC    '\\'
#define     KPRM    '$'
/*
*/
#define sametwo(a,b)((a[0]==b[0]&&a[1]==b[1])?1:0)
/*
*/
static  char    *msg1   = "%s: <bad ds/de name> '%2.2s'\n";
static  char    *msg3   = "%s: <ds/de too large>\n";
static  char    *msg4   = "%s: <ds/de loop>\n";
static  char    *msg5   = "%s: <ds/de overflow>\n";
static  char    *msg6   = "%s: <ds/de conflict> '%3.3s'\n";
static  int     nm;             /* NUMBER OF MACROS/STRINGS */
static  int     np;             /* NUMBER OF PARAMETERS */
static  int     pn;             /* PARAMETER NUMBER */
static  char    ps[BLKSIZ];     /* PARAMETER SAVE ARRAY */
static  char    ws[BLKSIZ];     /* WORK STRING FOR EXPANSION */
static  char    *psu = ps + BLKSIZ -1;
static  char    *wsx = NULL;
static	char	*wsu = ws + BLKSIZ -1;
static  char    ns[16];         /* NP AS STRING */
static  char    *pp[10];        /* PARAMETER STRINGS */
static  char    *mt[NMAC];      /* MACROS */
static  char    **mx = NULL;
/**/
/*TARGET*/
char	*
zapcom(is)		/* zap a comment */
char	*is;
{
	REG		UCHAR	*isx = is;
	REG		UCHAR	*osx = is;
/**/
	while(*isx != ZERO)	{
		if(*isx == '\\' && isx[1] == '"')	{
			isx += 2;
			while(*isx != ZERO)	++isx;
			}
		else	*osx++ = *isx++;
		}
/**/
	*osx = ZERO;
	isx = is;
	while(osx > isx)
	if(isspace(osx[-1]))	*(--osx) = ZERO;
	else					break;
	return(osx);
}
xrn(nv,is)  /* rename the named macro/string */
char    *is;
{
	REG     char    **mx;
	getqs(pp,4,is);
	xrm(nv,pp[1]);
	mx = ismac(pp[0]);
	if(mx)  strncpy(*mx,pp[1],2);
	return(nm);
}
xas(nv,is)  /* append to a string */
char    *is;
{
/*
**  .as xx string
**      0   1
*/
	getqs(pp,4,is);
	if((int)(mx = ismac(pp[0])))   wsx = strkat(wsx = ws, wsu, *mx+3);
	wsx = strkat(wsx,wsu,pp[1]);
	mdefine(pp[0],ws,KSTR);
}
xam(nv,is)  /* append to a macro */
char    *is;
{
/*
**  .am xx [..]
**      0   1
*/
	strcpy(ps,is);
	getqs(pp,4,ps);
	if((int)(mx = ismac(pp[0])))   wsx = strkat(ws,wsu,*mx+3);
	xde(nv,is);
	if((int)(mx = ismac(pp[0])))   {
		wsx = strkat(wsx,wsu,*mx+3);
		mdefine(pp[0],ws,KMAC);
		}
	return(ZERO);
}
xrm(nv,is)  /* remove the named macro/string */
char    *is;
{
	REG		NOSIGN	ix;
	for(ix = 0; ix < nm; ix++)	{
		if(is[0] == *mt[ix] && is[1] == *(mt[ix]+1))	{
			free_if(mt[ix]);
			for(ix += 1; ix < nm; ix++)		{
				mt[ix-1] = mt[ix];
				}
			nm -= 1;
			break;
			}
		}
	return(nm);
}
xds(nv,is) /* DEFINE A STRING */
char    *is;
{
	savecmd(is);
	getqs(pp,3,is);
	mdefine(pp[0],pp[1],KSTR);
	return(ZERO);
}
char	*
mdefine(os,is,ty)   /* ADD A MACRO OR STRING */
char	*os;		/* macro name */
char	*is;		/* macro text */
int		ty;			/* type */
{
	auto	UCHAR    *osx = NULL;
	/* CHECK NAME */
	if(!isalpha(os[0]) || strlen(os) != 2) {
		errmsg(msg1,"mdefine",os);
		terror(FUBAR);
		}
	/* REMOVE ANY PREVIOUS DEFINITION */
	if((int)(mx = ismac(os)))	{
		xrm(0,os);
		if(isatty(1))	{
			errmsg("mdefine <ds/de redefinition> %s '%s'\n",
				filepush(filepop()),os);
		}
	}
	/* IF NO TEXT, RETURN */
	if(isnull(is))      return(NULL);
	/* CHECK FOR SPACE */
	if(nm >= NMAC)	{
		errmsg("mdefine <too many ds/de> %d >= %d\n",nm,NMAC);
		terror(FUBAR);
	}
	/* GET SPACE FOR STRING */
	osx = emalloc(strlen(os)+strlen(is)+8,"mdefine:osx");
	/* CREATE STRING */
	strncpy(osx,os,2);
	osx[2] = ty;
	strcpy(osx+3,is);
	savecmd("");
	mt[nm] = osx;
	nm += 1;
	return(osx);
}
char	*
mexpand(os,us)      /* EXPAND MACROS/STRINGS */
char    *os,    *us;
{
	REG     UCHAR    *osx = os;
	REG     UCHAR    *usx = us;
	REG     USHORT   loop = LOOP;
	auto    USHORT   mac = 0;
#ifdef	DEBUG
	if(kenv.diagno & DB) 
	fprintf(stderr,"(0) mexpand(%u,%u,%s)\n",os,us,os);
#endif
	if(*osx == KMAC)    {
		if((int)(mx = ismac(osx+1))) {
		mac = 1;
		if((*mx)[2] != KMAC)    {
			errmsg(msg6,"mexpand",osx);
			terror(FUBAR);
			}
		strkat(ps,psu,osx+3);
		np = getqs(pp+1,9,ps);
		itos(pp[0] = ns, np);
		osx[3] = ZERO;
		wsx = strkat(ws ,wsu,*mx+3);
		wsx = strkat(wsx,wsu,osx+3);
		strkat(os,usx,ws);
		}
	}
	while(loop-- >= 1 && *osx != ZERO && osx < usx)
	{
	if(*osx == KESC) osx = mescape(osx,usx);
	else
	if(*osx == KPRM && mac && isdigit(osx[1])) {
		pn = osx[1] - '0';
		wsx = strkat(ws ,wsu,pp[pn]);
		wsx = strkat(wsx,wsu,osx+2);
		strkat(osx,usx,ws);
		}
	else
	if(*osx == KSTR && isalpha(osx[1]) && isalnum(osx[2]))  {
		if((int)(mx = ismac(osx+1)))   {
			if((*mx)[2] != KSTR)    {
				errmsg(msg6,"mescape",osx);
				terror(FUBAR);
				}
			wsx = strkat(ws ,wsu,*mx+3);
			wsx = strkat(wsx,wsu,osx+3);
			strkat(osx,usx,ws);
			}
		else    strcpy(osx,osx+3);
		}
	else        osx += 1;
	}
	if(loop <= 0) {
		errmsg(msg4,"mescape");
		terror(FUBAR);
		}
	if(osx >= usx) {
		errmsg(msg5,"mescape");
		terror(FUBAR);
		}
#ifdef	DEBUG
	if(kenv.diagno & DB) 
	fprintf(stderr,"(1) mexpand(%u,%u,%s)\n",os,us,os);
#endif
	return(os);
}
char    *
mescape(os,us)
char    *os, *us;
{
/*
**  \$  \.
**  \X
**  \NULL
*/
	if(os[1] == KSTR || os[1] == KMAC || os[1] == KPRM) {
		strcpy(os,os+1);
		return(os+1);
		}
	else return(os+1);
}
char    **
ismac(is)    /* RETURN POINTER TO MACRO/STRING TEXT OR NULL */
char    *is;
{
	REG		NOSIGN	ix;
#ifdef	HIGHP
	static	NOSIGN	hp = ZERO;
#endif	HIGHP
	for(ix = 0; ix < nm; ix++)	{
		if(is[0] == *mt[ix] && is[1] == *(mt[ix]+1))	{
#ifdef	HIGHP
			hp = hp >= NMAC ? 0 : hp;
			if(ix > hp)	{
				char	*zx = mt[hp];
				mt[hp] = mt[ix];
				mt[ix] = zx;
				ix = hp;
				hp += 1;
				}
#endif	HIGHP
			return(mt+ix);
			}
		}
	return(NULL);
}
xde(nv,is)  /* GET A MACRO FROM STREAM FP */
char    *is;
{
	auto	char	*ls = emalloc(BLKSIZ,"xde");
	auto    char    ts[3];
	auto    char    ns[3];
	REG     char    *tsx;
	REG     char    *lsx = ls;
	REG     char    *lsu = ls + BLKSIZ -1;
	auto	int		skip;
/**/
	savecmd(is);
/**/
	getqs(pp,4,is);
/**/
	strncpy(ns,pp[0],3);
/**/
	if(isnull(pp[1]))       strncpy(ts,"..",3);
	else                    strncpy(ts,pp[1],3);
/**/
	while((int)(lsx = fgetlk(tsx = lsx,lsu,x[nv].ifp)))	{
/**/
	skip = NO;
/**/
	lsx = zapcom(tsx);
/**/
	if(isnull(tsx))	skip = YES;
/**/
	skip = ((tsx[0] == x[nv].cc || tsx[0] == x[nv].c2) &&
		((tsx[1] == 'm' && tsx[2] == 'o'))) ?	1 : skip;
	if(skip)	{
		lsx = tsx;
		continue;
		}
/**/
	if(sametwo(tsx,ts)) break;
	else
	if(lsx < lsu)   *lsx++ = '\n';
	}
/**/
	if(lsx == NULL) badeof(nv,"xde",FUBAR);
/**/
	if(lsx >= lsu)   {
		errmsg(msg3,"xde");
		fputs(ls,stderr);
		putc('\n',stderr);
		terror(FUBAR);
		}
/**/
	lsx[-3] = ZERO;
/**/
	mdefine(ns,ls,KMAC);
/**/
	savecmd("");
/**/
	ls = free_if(ls);
/**/
	return(ZERO);
}
xpm(nv,is)     /* PRINT MACRO AND STRING DEFINITIONS */
char    *is;
{
	REG     int     i;
	REG     FILE    *fp = stderr;
	switch(*is) {
	case    'E':    fflush(x[nv].ofp);
	case    'e':    fp = stderr;
					break;
	case    'T':    fflush(x[nv].ofp);
	default:
	case    't':    fp = x[nv].ofp;
	}
	for(i = 0; i < nm ; i++)    {
		if(fp == stderr)    {
			fputut(mt[i],fp,0);
			putc('\n',fp);
			}
		else                tblwrt(nv,mt[i]);
		}
	fflush(x[nv].ofp);
	return(ZERO);
}
