/*COMLIB*/
/*
	maintain a chain of saved strings and strchr numbers to
	these strings;  the strchr numbers are consecutive and
	may be used as array subscripts.
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERN*/
/**/
static	int		how;
/**/
static 	struct	NUMSTR	{
	char			*nsm;
	struct	NUMSTR	*nsx;
}	*nbase, *nlast;
strhow()		/* how many elements are in the chain */
{
	return(how);
}
char	*
strnum(ty)		/* return string for n-th element of chain */
int		ty;
{
	register	struct	NUMSTR	*xs = nbase;
	register	int				xn = 0;
	while(xs != ZERO)	{
		if(xn == ty)	{
			return(xs->nsm);
			}
		xn += 1;
		xs = xs->nsx;
		}
	return(NULL);
}
numstr(is)
char	*is;
{
	register	struct	NUMSTR	*xs = nbase;
	register	int				xn = 0;
	if(is == NULL)	{
		while(xs != ZERO)	{
			free_if( (char *) xs->nsm);
			free_if( (char *) xs);
			xs = xs->nsx;
			}
		nbase = nlast = (struct NUMSTR *) NULL;
		return(how = 0);
		}
	while(xs != ZERO)	{
		if(is[0] == xs->nsm[0] &&
			strcmp(is,xs->nsm) == 0)	return(xn);
		xs = xs->nsx;
		xn += 1;
		}
	xs = (struct NUMSTR *) emalloc( sizeof(struct NUMSTR) , "numstr");
	xs->nsm = strsave(is);
	xs->nsx = (struct NUMSTR *) NULL;
	if(nbase == (struct NUMSTR *) NULL)	nbase = xs;
	if(nlast)			nlast->nsx = xs;
	nlast = xs;
	how = xn + 1;
	return(xn);
}
#ifdef	TEST
fubar(ty)
{
	abort(ty);
}
main()
{
	auto	char	ls[BUFSIZ];
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'!':	numstr(NULL);
					break;
	case	'?':	printf("%d\n",strhow());
					break;
	case	'#':	printf("%s\n",strnum(atoi(ls+1)));
					break;
	default:		printf("%2d %s\n",numstr(ls),ls);
					break;
	}
}
#endif
