/*
	convert comments to upper or lower case or extract comments
	without conversion
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERN*/
extern int upcom();
extern int excom();
extern int locom();
extern int comment();
/*LOCAL*/
KENV kenv;
int (*func)();
void
terror(ty)
int		ty;
{
	exit(ty);
}
hint(fp)
FILE	*fp;
{
	static	char	*hx[] = {
"=comment [-options] file(s)",
"*",
"*		process C language comments",
"*",
"-f     file name to extracted comments",
"-l		comments to lower case",
"-x		extract comments",
"-u		comments to upper case [default]",
"=BUGS",
"		fails if /* or */ occur in quoted strings",
"=",
"~",
		}	;
	prhint(hx,sizeof(hx)/sizeof(char *),ZERO,NULL);
	if(fp == stderr)	exit(FUBAR);
	else				exit(0);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "comment");
	exit(cmdxrc(argc,argv,comment,"comment.xrc"));
}
comment(argc,argv)
int		argc;
char	*argv[];
{
	if(kenv.dosdos)	cmdxpd(argc,argv);
	func = upcom;
	if(cmdnum(argc,argv,'h',0,1))	hint(stdout);
	if(cmdnum(argc,argv,'u',0,1))	func = upcom;
	if(cmdnum(argc,argv,'l',0,1))	func = locom;
	if(cmdnum(argc,argv,'x',0,1))	func = excom;
	kenv.flags0 = cmdnum(argc,argv,'f',0,1);
	dolist(argc,argv,func);
}
upcom(fp)	/* comments to upper case */
FILE	*fp;
{
	auto	int		cx = 0;
	auto	int		lx = 0;
	auto	int		ch = 0;
	while( (cx = getc(fp)) != EOF)	{
		if(cx == '*' && lx == '/')	ch = 1;
		else
		if(cx == '/' && lx == '*')	ch = 0;
		cx = ch ? toupper(cx) : cx;
		putc(lx = cx, stdout);
		}
	return(0);
}
locom(fp)	/* comments to lower case */
FILE	*fp;
{
	auto	int		cx = 0;
	auto	int		lx = 0;
	auto	int		ch = 0;
	while( (cx = getc(fp)) != EOF)	{
		if(cx == '*' && lx == '/')	ch = 1;
		else
		if(cx == '/' && lx == '*')	ch = 0;
		cx = ch ? tolower(cx) : cx;
		putc(lx = cx, stdout);
		}
	return(0);
}
excom(fp)	/* comments extracted */
FILE	*fp;
{
	auto	int		cx = 0;
	auto	int		lx = 0;
	auto	int		ch = 0;
	auto	int		fl = 0;
	while( (cx = getc(fp)) != EOF)	{
		if(cx == '/')	{
			cx = getc(fp);
			if(cx == '*')	{
				if(fl == 0 && kenv.flags0 == 1)	{
					fprintf(stderr,"===>%s<===\n",getcfn());
					}
				fputs("\n/*\n",stdout);
				ch = 1;
				}
			}
		else
		if(cx == '*')	{
			cx = getc(fp);
			if(cx == '/')	{
				fputs("\n*/\n",stdout);
				ch = 0;
				}
			}
		else
		if(ch)	putc(cx,stdout);
		}
	return(0);
}
