#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/*
	UNIX style termcap routines for MSDOS version
*/
/**/
#define		COLON		':'
#define		VBARS		'|'
#define		EQALS		'='
#define		BACKSL		'\\'
#define		SLASH		'/'
#define		BIGEEE		'E'
#define		ESCAPE		'\033'
#define		SHARP		'#'
#define		NEGONE		-1
/**/
/*EXTERNAL*/
extern	char	*strchr();
/**/
static	char	*tcap = NULL;
/**/
tgetent(os,us,tt)
char	*os;
char	*us;
char	*tt;
{
	static	char	*here = "tgetent";
	auto	char	*termcap = kgetenv("TERMCAP");
	auto	char	ws[FNMSIZ];
	auto	char	*colon;
	auto	FILE	*tp;
	auto	char	*osx;
/**/
	tcap = NULL;
/**/
	if(isnull(termcap))	{
		errmsg("%s <no TERMCAP in environment>\n",here);
		}
/**/
	strkat(ws,ws+FNMSIZ-1,termcap);
/**/
	tp = tefopen(ws,kenv.dosdos ? "rb" : "r");
/**/
	while(tcap == NULL && fgetlf(osx = os,us,tp))		{
		colon = index(os,COLON);
		if(colon)	*colon = NULL;
		else		continue;
		while(osx = xgnc(ws,ws+FNMSIZ-1,osx,VBARS))	{
			if(strcmp(tt,ws) == 0)	{
				tcap = colon + 1;
				break;
				}
			}
	}
/**/
	if(tcap == NULL)	{
		errmsg("tgetent <unknown terminal> '%s'\n",tt);
		return(1);
		}
/**/
	tp = xfclose(tp);
/**/
	return(ZERO);
}
char	*
bige(is)
char	*is;
{
	REG		char		*isx = is;
	REG		char		*osx = is;
	while(*isx != 0)
	if(*isx == '\\' && isx[1] == 'E')	{
		*osx++ = '\033';
		isx += 2;
		}
	else	*osx++ = *isx++;
	*osx++ = ZERO;
	return(is);
}
char	*
tgetstr(os,is)
char	*os;
char	**is;
{
	auto	char	ws[FNMSIZ];
	auto	char	*tsx = tcap;
	auto	char	*tsz;
	auto	int		ls;
	while(tsx = xgnc(ws,ws+FNMSIZ-1,tsx,COLON))	{
		if(os[0] == ws[0] && os[1] == ws[1] && ws[2] == EQALS)	{
			ls = strlen(ws+3) + 1;
			bige(ws+3);
			xesc(ws+3);
			strcpy(tsx = *is,ws+3);
			*is += ls;
			return(tsx);
			}
		}
	return(NULL);
}
tgetnum(os)
char	*os;
{
	REG		char	*tcx = tcap;
	REG		char	*osx = os;
	while(*tcx != ZERO)	{
	if(*tcx == *osx && strncmp(tcx,osx,2) == 0 &&
		tcx[2] == SHARP)	{
			return(atoi(tcx+3));
			}
	else	tcx += 1;
	}
	return(NEGONE);
}
tgetflag(os)
char	*os;
{
	REG		char	*tcx = tcap;
	REG		char	*osx = os;
	while(*tcx != ZERO)	{
	if(*tcx == *osx && strncmp(tcx,osx,2) == 0 &&
		tcx[2] == COLON)	{
			return(1);
			}
	else	tcx += 1;
	}
	return(ZERO);
}
#ifdef	TEST
KENV	kenv;
#define	TSIZ	(BUFSIZ * 2)
main(argc,argv)
int		argc;
char	*argv[];
{
	auto	char	zs[TSIZ];
	auto	char	bs[BUFSIZ];
	auto	char	ls[BUFSIZ];
	auto	char	*ts = bs;
	auto	char	*xs;
	auto	int	i;
	while(putchar('?'),gets(ls))
	switch(ls[0])	{
		case	'#':	printf("%d\n",tgetnum(strcnd(ls+1)));
						break;
		case	'T':	tgetent(zs,zs+TSIZ-1,strcnd(ls+1));
						funxesc(zs,stdout);
						break;
		case	'D':	fputs(xs,stdout);
						break;
		default:		xs = tgetstr(ls,&ts);
						funxesc(xs,stdout);
						break;
		}
}
#endif
