#define		TRACE
#ifdef		ALLOCATE
#define		EXTERN		/**/
#else		/*ALLOCATE*/
#define		EXTERN		extern
#endif		/*ALLOCATE*/
/**/
#define		FNAME		/* compare only file name portion */
/**/
#ifdef		V7
#define		DIRTYPE		0
#endif
/**/
#ifdef		V29
#define		DIRTYPE		0
#endif
/**/
#ifdef		V42
#define		DIRTYPE		1
#endif
/**/
#ifdef		MSDOS
#define		DIRTYPE		2
#define		strcmp(a,b)stricmp(a,b)
#define		strncmp(a,b,c)strnicmp(a,b,c)
#endif
/**/
#include    "ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<sys/types.h>
#include	<sys/stat.h>
#ifdef	__TURBOC__
#include	<conio.h>
#include	<time.h>
#include	<stdlib.h>
#endif
#ifdef	V29
#undef	void	/* already has dumb definition */
#endif	V29
/**/
#ifdef		MSDOS
#else		MSDOS
#include	<sys/dir.h>
#endif 		MSDOS
/**/
#define			NZAP		32
#define			NDIR		512	/* number of directories or files */
#define			NPRG		512	/* number of elements in program */
#define			NSTK		128	/* stack size */
#define			ONE_DAY		(long) (24L * 3600L)	/* one day in seconds */
#define			STOP		( (FUNCS) (NULL) )
/*TYPEDEF*/
typedef	struct	stat	STAT;
typedef	union	PROG	{
	FUNCS	func;			/* routine to execute */
	long	value;			/* numerical value */
	char	*string;		/* target string */
	union	PROG	*next;	/* next code */
	}	PROG;
typedef	struct	TREE	{
	char	*sig;		/* signature of function */
	void	(*fun)();	/* function to execute */
	char	**(*ppf)();	/* parameter pulling function */
	}	TREE;
/*GLOBAL*/
EXTERN	KENV	kenv;
EXTERN	char	**argx;			/* parse pointer */
EXTERN	char	**argu;			/* parse pointer */
EXTERN	char	fname[FNMSIZ];	/* file name portion */
EXTERN	char	cmd[BUFSIZ];	/* shell command buffer */
EXTERN	char	*cfn;			/* current file name */
EXTERN	int		ndir;			/* number of directories or files */
EXTERN	char	*dlist[NDIR];	/* directory or file list */
EXTERN	PROG	prog[NPRG];		/* program to execute */
EXTERN	PROG	*prx;			/* program pointer */
EXTERN	PROG	*pru;			/* program pointer */
EXTERN	int		stack[NSTK];	/* evaluation stack */
EXTERN	int		*sp;			/* stack pointer */
EXTERN	STAT	sbuf;			/* stat buffer */
EXTERN	long	curt;			/* current time for ?time functions */
/*EXTERN*/
#ifndef	__TURBOC__
#ifdef	CAN_PROTO
extern int system(char *);
extern void qsort(char *,unsigned,unsigned,int(*)());
extern void free(char *);
extern long atol(char *);
extern void andlist(void);
extern int fread(char *,unsigned,unsigned,FILE *);
extern int unlink(char *);
extern void dounlink(void);
extern char *fputs(char *,FILE *);
extern void fflush(FILE *);
extern void fclose(FILE *);
extern int cgets(char *);
extern char *fgets(char *,FILE *);
extern char *ctime(long *);
#else	/*CAN_PROTO*/
extern void andlist();
extern int fread();
extern int unlink();
extern void dounlink();
extern char *fputs();
extern void fflush();
extern void fclose();
extern int cgets();
extern char *fgets();
extern char *ctime();
#endif	/*CAN_PROTO*/
#endif	/*TURBOC*/
#ifdef	CAN_PROTO
extern long textlength(char *);
extern long ktimedtx(long);
extern char **candlist(char **);
extern char **cexpr(char **);
extern char **corlist(char **);
extern char **cprimary(char **);
extern char **getcmd(char **);
extern char **getfunc(char **);
extern char **getid(char **);
extern char **getnewer(char **);
extern char **getoct(char **);
extern char **getstring(char **);
extern char **gettype(char **);
extern char *format(STAT *,char *,char *);
extern char *getfname(char *,char *,char *);
extern TREE *intree(char *);
extern char *makeshell(char *, char *, char *,char *);
extern char *namerf(char *);
extern char *strcnd(char *);
extern char *xgnc(char *, char *, char *, int);
extern void allcode(char *);
extern void andlist(void);
extern void andnext(void);
extern long blocknum(long);
extern int close(int);
extern int cquery(char *);
extern void doatime(void);
extern void dobinary(void);
extern void doctime(void);
extern void doexec(void);
extern void doformat(void);
extern void dogid(void);
extern void doinum(void);
extern void dolink(void);
extern void domtime(void);
extern void doname(void);
extern void donewer(void);
extern void dookay(void);
extern void doperm(void);
extern void doprint(void);
extern int doscan(char **,int);
extern void dosize(void);
extern void dotype(void);
extern void douid(void);
extern void dounlink(void);
extern void dscan(char *);
extern void equalto(long,long);
extern void errmsg();
extern int fprintf();
extern int fputc(int, FILE *);
extern void fscan(char *);
extern int getdir(int,char **);
extern int getmtime(int, char **);
extern int getprg(int,char **);
extern int getpri(int,char **);
extern void hint(int);
extern void lessthan(long,long);
extern void morethan(long,long);
extern void negate(void);
extern int newtree(int, char **);
extern int open(char *,int);
extern void orlist(void);
extern void ornext(void);
extern int printf();
extern void prtcmd(int,char **);
extern void prterr();
extern void prwho();
extern int read(int,char *,int);
extern long roundup(long,long);
extern void showcode(PROG *,char *);
extern int sscanf();
extern int stat(char *,struct stat *);
extern int strcmd(int,char **);
extern long time(long *);
extern long truncate(long,long);
extern void xecute(void);
#else	/*CAN_PROTO*/
extern long textlength();
extern long ktimedtx();
extern char **candlist();
extern char **cexpr();
extern char **corlist();
extern char **cprimary();
extern char **getcmd();
extern char **getfunc();
extern char **getid();
extern char **getnewer();
extern char **getoct();
extern char **getstring();
extern char **gettype();
extern char *format();
extern char *getfname();
extern TREE *intree();
extern char *makeshell();
extern char *namerf();
extern char *strcnd();
extern char *xgnc();
extern void allcode();
extern void andlist();
extern void andnext();
extern long atol();
extern long blocknum();
extern int close();
extern int cquery();
extern void doatime();
extern void dobinary();
extern void doctime();
extern void doexec();
extern void doformat();
extern void dogid();
extern void doinum();
extern void dolink();
extern void domtime();
extern void doname();
extern void donewer();
extern void dookay();
extern void doperm();
extern void doprint();
extern int doscan();
extern void dosize();
extern void dotype();
extern void douid();
extern void dounlink();
extern void dscan();
extern void equalto();
extern void errmsg();
extern int fprintf();
extern int fputc();
extern void free();
extern void fscan();
extern int getdir();
extern int getmtime();
extern int getprg();
extern int getpri();
extern void hint();
extern void lessthan();
extern void morethan();
extern void negate();
extern int newtree();
extern int open();
extern void orlist();
extern void ornext();
extern int printf();
extern void prtcmd();
extern void prterr();
extern void prwho();
extern void qsort();
extern int read();
extern long roundup();
extern void showcode();
extern int sscanf();
extern int stat();
extern int strcmd();
extern int system();
extern long time();
extern long truncate();
extern void xecute();
#endif	/*CAN_PROTO*/
#ifdef	ALLOCATE
TREE	tree[] = {
	"-at", doatime, getfunc,
	"-bi", dobinary, NULL,
	"-ct", doctime, getfunc,
	"-ex", doexec, getcmd,
	"-fo", doformat, getstring,
	"-gr", dogid, getid,
	"-in", doinum, getid,
	"-li", dolink, getfunc,
	"-mt", domtime, getfunc,
	"-na", doname, getstring,
	"-ne", donewer, getnewer,
	"-ok", dookay, getcmd,
	"-pe", doperm, getoct,
	"-pr", doprint, NULL,
	"-si", dosize, getfunc,
	"-ty", dotype, gettype,
	"-un", dounlink, NULL,
	"-us", douid, getid,
	NULL, NULL, NULL,
	}	;
#else	/*ALLOCATE*/
extern	TREE	tree[];
#endif	/*ALLOCATE*/
