/*
|	function prototypes for routines used in pdtar.
*/
#ifdef	M_XENIX
#define	const	/**/
#endif
#ifdef	CAN_PROTO
extern long cal_bif(long);
extern void takefile(char *);
extern long utimestd(void);
extern long dtimestd(void);
extern long ktimeutd(long);
extern long ktimedtu(long);
extern char *chgpath(char *);
extern char *chgtodos(char *,char *);
extern RECORD *chkhead(RECORD *);
extern char *cookit(char *);
extern char *ctime(const time_t *);
extern RECORD *decode(RECORD *);
extern char *digiskip(char *);
extern FILE *efopen(char *,char *,char *);
extern RECORD *encode(int,char *,char *,STAT *,RECORD *);
extern char *fixname(char *, char *,char *);
extern char *fromlist(FILE *);
extern char *getfile(int);
extern char *haslinks(ino_t,char *);
extern char *invalid(char *);
extern char *isolate(char *);
extern FILE *linklist(int);
extern char *maketemp(char *);
extern FILE *openlist(char *);
extern FILE *opentmp(char *,char *,char *,char *);
extern char *samefile(ino_t,char *);
extern char *showuppr(char *,int);
extern char *strcat(char *,char *);
extern char *strchr(char *,int);
extern char *strcnd(char *);
extern char *strcpy(char *,char *);
extern char *strdos(char *,char *);
extern char *strdup(char *);
extern char *strlpr(char *);
extern char *strlwr(char *);
extern char *strncpy(char *,char *,int);
extern char *strrchr(char *,int);
extern char *strstr(char *,char *);
extern char *strstr(char *,char *);
extern char *strupr(char *);
extern char *strxty(char *,int,int);
extern FILE *workfile(int);
extern FILE *xfclose(FILE *);
extern int absio(int,int,char *,int,int);
extern int accept(char *,STAT *);
extern int access(char *,int);
extern int arcgener(char *, STAT *);
extern int archive(void);
extern int arcnewer(char *, STAT *);
extern int askfloppy(char *);
extern long atol(const char *);
extern int badstat(char *,STAT *,char *);
extern int biosdisk(int,int,int,int,int,int,char *);
extern int cal_extno(long,int,int);
extern int chkopt(void);
extern int chmod(char *,int);
extern void cleanup(int);
extern int close(int);
extern int codename(int,RECORD *,char *);
extern int create(void);
extern int doalink(char *,char *);
extern int doaseg(char *,long,long);
extern int docrap(char *,STAT *);
extern int dodirt(char *,STAT *);
extern int doerrs(char *,FSIZE);
extern int dofile(char *,STAT *);
extern int doindex(char *,STAT *);
extern int dolink(char *,char *,STAT *);
extern int doperm(char *,STAT *);
extern int doskip(char *,STAT *);
extern int dotime(char *,STAT *);
extern int dotree(char *,STAT *);
extern int dstrcmp(char *,char *);
extern int dstrncmp(char *,char *,int);
extern int dupelink(char *,char *,STAT *);
extern void estimate(void);
extern int extract(void);
extern int fileblks(char *);
extern long from_oct(int,char *);
extern void getlist(int,char **);
extern void hint(FILE *);
extern int inisout(char *,char *);
extern int ishead(RECORD *);
extern long lseek(int,long,int);
extern int makelist(char *);
extern int makepath(char *);
extern void memcpy(char *,char *,int);
extern void memset(char *,int,int);
extern int mkdir(const char *);
extern int notfound(void);
extern int nullassign(char *,char *);
extern int open(char *,int,int);
extern int popact(FILE *,int,char *);
extern int prhead(char *,STAT *);
extern int pushact(int,int,long,long,int);
extern int rawdtest(int);
extern int rawread(char *,int,int);
extern int rawreset(int);
extern int rawwrite(char *,int,int);
extern int rdwrbios(int,int,int,int,int,int,char *);
extern int rdwrfile(char *,long,long);
extern int read(int,char *,int);
extern void readlist(char *);
extern int samename(char *, char *);
extern void savelist(char *);
extern void saver(char *);
extern int scanfile(char *);
extern int setcbrk(int);
extern int setdrive(int);
extern int setextent(int,long,long);
extern int setopt(int,char **);
extern int setspt(int);
extern int showname(char *,char *,char *);
extern int stat(char *,struct stat *);
extern int strcmp(char *,char *);
extern int stricmp(char *,char *);
extern int strlen(char *);
extern int strncmp(char *,char *,int);
extern int strnicmp(char *,char *,int);
extern int sysread(char *,int);
extern int syswrite(char *,int);
extern void takefile(char *);
extern int tar_close(void);
extern void tar_eof(void);
extern int tar_fetch(char *,int,char *);
extern int tar_place(char *,int,char *);
extern int tar_read(int);
extern int tar_write(int);
extern int tardefs(int);
extern int tellblocks(int,char *,char *,int);
extern void terror(int);
extern void terror(int);
extern long time(long *);
extern void to_oct(long,int,char *);
extern int unhinge(char *);
extern int unlink(const char *);
extern int utime(char *,long *);
extern int where(char *);
extern long wrdata(int,char *,long);
extern int wrfile(char *,STAT *);
extern int write(int,char *,int);
extern FSIZE zwrfile(FSIZE);
#else	/* CAN_PROTO */
extern void takefile();
extern long utimestd();
extern long dtimestd();
extern long ktimeutd();
extern long ktimedtu();
extern char *chgpath();
extern char *chgtodos();
extern RECORD *chkhead();
extern char *cookit();
extern char *ctime();
extern RECORD *decode();
extern char *digiskip();
extern FILE *efopen();
extern RECORD *encode();
extern char *fixname();
extern char *fromlist();
extern char *getfile();
extern char *haslinks();
extern char *invalid();
extern char *isolate();
extern FILE *linklist();
extern char *maketemp();
extern FILE *openlist();
extern FILE *opentmp();
extern char *samefile();
extern char *showuppr();
extern char *strcat();
extern char *strchr();
extern char *strcnd();
extern char *strcpy();
extern char *strdos();
extern char *strdup();
extern char *strlpr();
extern char *strlwr();
extern char *strncpy();
extern char *strrchr();
extern char *strstr();
extern char *strstr();
extern char *strupr();
extern char *strxty();
extern FILE *workfile();
extern FILE *xfclose();
extern int absio();
extern int accept();
extern int access();
extern int arcgener();
extern int archive();
extern int arcnewer();
extern int askfloppy();
extern long atol();
extern int badstat();
extern int biosdisk();
extern int cal_extno();
extern int chkopt();
extern int chmod();
extern void cleanup();
extern int close();
extern int codename();
extern int create();
extern int doalink();
extern int doaseg();
extern int docrap();
extern int dodirt();
extern int doerrs();
extern int dofile();
extern int doindex();
extern int dolink();
extern int doperm();
extern int doskip();
extern int dotime();
extern int dotree();
extern int dstrcmp();
extern int dstrncmp();
extern int dupelink();
extern void estimate();
extern int extract();
extern int fileblks();
extern long from_oct();
extern void getlist();
extern void hint();
extern int inisout();
extern int ishead();
extern long lseek();
extern int makelist();
extern int makepath();
extern void memcpy();
extern void memset();
extern int mkdir();
extern int notfound();
extern int nullassign();
extern int open();
extern int popact();
extern int prhead();
extern int pushact();
extern int rawdtest();
extern int rawread();
extern int rawreset();
extern int rawwrite();
extern int rdwrbios();
extern int rdwrfile();
extern int read();
extern void readlist();
extern int samename();
extern void savelist();
extern void saver();
extern int scanfile();
extern int setcbrk();
extern int setdrive();
extern int setextent();
extern int setopt();
extern int setspt();
extern int showname();
extern int stat();
extern int strcmp();
extern int stricmp();
extern int strlen();
extern int strncmp();
extern int strnicmp();
extern int sysread();
extern int syswrite();
extern void takefile();
extern int tar_close();
extern void tar_eof();
extern int tar_fetch();
extern int tar_place();
extern int tar_read();
extern int tar_write();
extern int tardefs();
extern int tellblocks();
extern void terror();
extern void terror();
extern long time();
extern void to_oct();
extern int unhinge();
extern int unlink();
extern int utime();
extern int where();
extern long wrdata();
extern int wrfile();
extern int write();
extern FSIZE zwrfile();
extern long cal_bif();
#endif	/* CAN_PROTO */
