#include	"pdtar.h"
#include	"pdproto.h"
/**/
#ifdef		SUN
#define		BSD
#endif
/**/
#ifdef		M_XENIX
/**/
#include	<sys/dir.h>
/**/
newcmp(os,is)	/* sort directory entries */
struct	direct	*os;
struct	direct	*is;
{
	return(dstrcmp(os->d_name,is->d_name));
}
dotree(f_name,phstat)	/* scan a directory */
char    *f_name;
STAT	*phstat;
{
	extern	char	*malloc();
	struct  direct  *dbuf;
	auto	char    *lx;
	auto	int		ix;
	auto	int		fd;
	auto	NOSIGN	sd;
	auto	NOSIGN	nd;
	auto	int		nc;
	nullassign(f_name,"dotree");
/*
	read whole directory, sort it, then process items one by one
*/
/**/
	lx = f_name + strlen(f_name);
	*lx++ = '/';
	*lx = 0;
/**/
	sd = (NOSIGN) phstat->st_size;
	nd = sd / sizeof(struct direct);
	dbuf = (struct direct *) malloc( sd );
	if(dbuf == (struct direct *) NULL)	{
		fprintf(stderr,"dotree <no core> %u\n",nd);
		terror(FUBAR);
		}
/**/
	if((fd = open(f_name,O_RDONLY,0)) < 0)	{
		perror(f_name);
		*--lx = 0;
		return(0);
		}
/**/
	nc = read(fd,(char *) dbuf,sd);
	if(nc != sd)	{
		fprintf(stderr,"dotree <read error> '%s'\n",f_name);
		terror(FUBAR);
		}
/**/
	qsort((char *) dbuf, nd, sizeof(struct direct), newcmp);
/**/
	for(ix = 0; ix < nd; ix++)	{
		if(dbuf[ix].d_ino == 0)          			continue;
		if(strcmp(dbuf[ix].d_name,".") == 0)    	continue;
		if(strcmp(dbuf[ix].d_name,"..") == 0)   	continue;
/*
	don't make the mistake of using DIRSIZ here
*/
#define	MAXNAME	14
		strncpy(lx,dbuf[ix].d_name,MAXNAME);
		lx[MAXNAME] = 0;
		scanfile(f_name);
/**/
		}
/**/
	close(fd);
/**/
	free(dbuf);
/**/
	*--lx = 0;
/**/
	return(0);
}
#endif
#ifdef	MSDOS
#include	<stdio.h>
#include	<dir.h>
#include	<dos.h>
haswild(is)
char	*is;
{
	while(*is != 0)
	switch(*is++)	{
		case	'?':
		case	'*':
			return(1);
		default:
			break;
		}
	return(0);
}
dotree(f_name,phstat)
char	*f_name;
STAT	*phstat;
{
	static	char	*here = "dotree";
	auto	int		done;
	auto	int		len = strlen(f_name);
	auto	char	*eop = f_name + len;
	auto	struct	ffblk	ffblk;
	auto	char	ws[NAMSIZ];
	auto	char	*wsx = NULL;
/**/
#ifdef	DEBUG
	nullassign(f_name,here);
	fprintf(stderr,"dotree(%s,%u)\n",f_name,phstat);
#endif
/**/
	strcpy(ws,f_name);
	wsx = strlen(ws) + ws;
	nullassign(wsx,here);
	*wsx++ = '/';
/**/
	*eop++ = '/';
	strcpy(eop,"*.*");
/**/
	done = findfirst(f_name,&ffblk,16);
	while(!done)	{
		if(dstrcmp(ffblk.ff_name,".") == 0)	;
		else
		if(dstrcmp(ffblk.ff_name,"..") == 0)	;
		else	{
			strcpy(wsx,ffblk.ff_name);
			strlwr(wsx);
			scanfile(ws);
			}
		done = findnext(&ffblk);
		}
	*--eop = 0;
	return(0);
}
#endif
scanfile(f_name)
char	*f_name;
{
	static	char	*here = "scanfile";
	nullassign(f_name,here);
/**/
	if(f_name[0] == 'C' && f_name[1] == ' ')	{
		if(chdir(f_name+2))	{
			where(here);
			fprintf(stderr,"<cannot cd> '%s'\n",f_name+2);
			terror(FUBAR);
			}
		fprintf(xfp,"%s\n",f_name);
		return(0);
		}
/**/
	phstat = &hstat;
	if(badstat(f_name,phstat,here) < 0)	return(-1);
/**/
#ifdef	MSDOS
	if(!oswitch.rawio && inisout(f_name,afn))	return(-1);
#else
	if(pwhoami && pwhoami->st_ino == phstat->st_ino)	{
		where(here);
		fprintf(stderr,"<output file in input list>\n");
		return(-1);
		}
#endif
	if(phstat->st_mode & S_IFDIR)	return(dotree(f_name,phstat));
	else
	if(phstat->st_mode & S_IFREG)	return(doindex(f_name,phstat));
else	{
		where(here);
		fprintf(stderr,"<unknown file type> '%s'\n",f_name);
		return(-1);
		}
}
#ifdef	MSDOS
inisout(os,is)		/* try to avoid recursion */
char	*os;
char	*is;
{
	register	char	*osx = os;
	register	char	*isx = is;
	while(*osx == '.' || *osx == '/' || *osx == '\\')	++osx;
	while(*isx == '.' || *isx == '/' || *isx == '\\')	++isx;
	if(stricmp(osx,isx) == 0)	{
		where("inisout");
		fprintf(stderr,"<archive in input list> %s == %s\n",os,is);
		return(1);
		}
	return(0);
}
#endif
#ifndef	MSDOS
#ifdef	DEBUG
prtdir(dbuf,nd)
struct	direct	dbuf[];
{
	auto	int		ix;
	for(ix = 0; ix < nd; ix++)	printf("%u %s\n",ix,dbuf[ix].d_name);
}
#endif
#endif
#ifdef		BSD
#include	<sys/types.h>
#include	<sys/dir.h>
/**/
dotree(f_name,phstat)	/* scan a directory */
char    *f_name;
STAT	*phstat;
{
	extern  int             alphasort();
	auto    int             i;
	auto    int             nid;
	auto    char            *lx;
	auto    struct  direct  **dl;
/**/
	lx = f_name + strlen(f_name);
	*lx++ = '/';
	*lx = ZERO;
	nid = scandir(f_name,&dl,NULL,alphasort);
	for(i = 0; i < nid; i++)    {
		if(strcmp(dl[i]->d_name,".") == 0)    continue;
		if(strcmp(dl[i]->d_name,"..") == 0)   continue;
		strcpy(lx,dl[i]->d_name);
		free(dl[i]->d_name);
		scanfile(f_name);
		}
	*--lx = ZERO;
	free(dl);
	return;
}
#endif
